<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AddRegistration' => '\\StructType\\AddRegistration',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'AddRegistrationResponse' => '\\StructType\\AddRegistrationResponse',
            'RegistrationAddResponse' => '\\StructType\\RegistrationAddResponse',
            'Result' => '\\StructType\\Result',
            'ArrayOfError' => '\\ArrayType\\ArrayOfError',
            'Error' => '\\StructType\\Error',
            'GUID' => '\\StructType\\GUID',
            'CancelRegistration' => '\\StructType\\CancelRegistration',
            'CancelRegistrationResponse' => '\\StructType\\CancelRegistrationResponse',
            'Response' => '\\StructType\\Response',
            'GetRegistrationActivityReport' => '\\StructType\\GetRegistrationActivityReport',
            'GetRegistrationActivityReportResponse' => '\\StructType\\GetRegistrationActivityReportResponse',
            'ActivityReportResponse' => '\\StructType\\ActivityReportResponse',
            'ArrayOfActivity' => '\\ArrayType\\ArrayOfActivity',
            'Activity' => '\\StructType\\Activity',
            'Timespan' => '\\StructType\\Timespan',
            'GetRegistrationProgressReport' => '\\StructType\\GetRegistrationProgressReport',
            'GetRegistrationProgressReportResponse' => '\\StructType\\GetRegistrationProgressReportResponse',
            'ProgressReportResponse' => '\\StructType\\ProgressReportResponse',
            'Progress' => '\\StructType\\Progress',
            'Date' => '\\StructType\\Date',
            'Custom' => '\\StructType\\Custom',
            'Field' => '\\StructType\\Field',
            'GetRegistrations' => '\\StructType\\GetRegistrations',
            'RegistrationsFilter' => '\\StructType\\RegistrationsFilter',
            'ArrayOfGUID' => '\\ArrayType\\ArrayOfGUID',
            'ArrayOfRegistrationStatus' => '\\ArrayType\\ArrayOfRegistrationStatus',
            'DateRange' => '\\StructType\\DateRange',
            'ArrayOfString1' => '\\ArrayType\\ArrayOfString1',
            'ArrayOfGUID1' => '\\ArrayType\\ArrayOfGUID1',
            'ArrayOfString2' => '\\ArrayType\\ArrayOfString2',
            'ArrayOfString3' => '\\ArrayType\\ArrayOfString3',
            'Tags' => '\\StructType\\Tags',
            'ArrayOfRegistrationIncludeField4_1' => '\\ArrayType\\ArrayOfRegistrationIncludeField4_1',
            'GetRegistrationsResponse' => '\\StructType\\GetRegistrationsResponse',
            'RegistrationsResponse' => '\\StructType\\RegistrationsResponse',
            'ArrayOfRegistration' => '\\ArrayType\\ArrayOfRegistration',
            'Registration' => '\\StructType\\Registration',
            'Price' => '\\StructType\\Price',
            'GetSingleSignOn' => '\\StructType\\GetSingleSignOn',
            'GetSingleSignOnResponse' => '\\StructType\\GetSingleSignOnResponse',
            'RegistrationSingleSignOnResponse' => '\\StructType\\RegistrationSingleSignOnResponse',
            'SingleSignOn' => '\\StructType\\SingleSignOn',
            'Form' => '\\StructType\\Form',
            'EncodedValue' => '\\StructType\\EncodedValue',
            'ArrayOfInput' => '\\ArrayType\\ArrayOfInput',
            'Input' => '\\StructType\\Input',
            'UpdateRegistration' => '\\StructType\\UpdateRegistration',
            'UpdateRegistrationResponse' => '\\StructType\\UpdateRegistrationResponse',
        );
    }
}
