<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegistrationsFilter StructType
 * @subpackage Structs
 */
class RegistrationsFilter extends AbstractStructBase
{
    /**
     * The RegistrationKeys
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGUID
     */
    public $RegistrationKeys;
    /**
     * The RegistrationStatuses
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfRegistrationStatus
     */
    public $RegistrationStatuses;
    /**
     * The RegistrationDateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateRange
     */
    public $RegistrationDateRange;
    /**
     * The AccessStartDateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateRange
     */
    public $AccessStartDateRange;
    /**
     * The AccessEndDateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateRange
     */
    public $AccessEndDateRange;
    /**
     * The CompletionDateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateRange
     */
    public $CompletionDateRange;
    /**
     * The CourseCodes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString1
     */
    public $CourseCodes;
    /**
     * The StudentKeys
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGUID1
     */
    public $StudentKeys;
    /**
     * The CustomStudentKeys
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString2
     */
    public $CustomStudentKeys;
    /**
     * The SectionNumbers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString3
     */
    public $SectionNumbers;
    /**
     * The LastModifiedDateRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateRange
     */
    public $LastModifiedDateRange;
    /**
     * The Tags
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Tags
     */
    public $Tags;
    /**
     * Constructor method for RegistrationsFilter
     * @uses RegistrationsFilter::setRegistrationKeys()
     * @uses RegistrationsFilter::setRegistrationStatuses()
     * @uses RegistrationsFilter::setRegistrationDateRange()
     * @uses RegistrationsFilter::setAccessStartDateRange()
     * @uses RegistrationsFilter::setAccessEndDateRange()
     * @uses RegistrationsFilter::setCompletionDateRange()
     * @uses RegistrationsFilter::setCourseCodes()
     * @uses RegistrationsFilter::setStudentKeys()
     * @uses RegistrationsFilter::setCustomStudentKeys()
     * @uses RegistrationsFilter::setSectionNumbers()
     * @uses RegistrationsFilter::setLastModifiedDateRange()
     * @uses RegistrationsFilter::setTags()
     * @param \ArrayType\ArrayOfGUID $registrationKeys
     * @param \ArrayType\ArrayOfRegistrationStatus $registrationStatuses
     * @param \StructType\DateRange $registrationDateRange
     * @param \StructType\DateRange $accessStartDateRange
     * @param \StructType\DateRange $accessEndDateRange
     * @param \StructType\DateRange $completionDateRange
     * @param \ArrayType\ArrayOfString1 $courseCodes
     * @param \ArrayType\ArrayOfGUID1 $studentKeys
     * @param \ArrayType\ArrayOfString2 $customStudentKeys
     * @param \ArrayType\ArrayOfString3 $sectionNumbers
     * @param \StructType\DateRange $lastModifiedDateRange
     * @param \StructType\Tags $tags
     */
    public function __construct(\ArrayType\ArrayOfGUID $registrationKeys = null, \ArrayType\ArrayOfRegistrationStatus $registrationStatuses = null, \StructType\DateRange $registrationDateRange = null, \StructType\DateRange $accessStartDateRange = null, \StructType\DateRange $accessEndDateRange = null, \StructType\DateRange $completionDateRange = null, \ArrayType\ArrayOfString1 $courseCodes = null, \ArrayType\ArrayOfGUID1 $studentKeys = null, \ArrayType\ArrayOfString2 $customStudentKeys = null, \ArrayType\ArrayOfString3 $sectionNumbers = null, \StructType\DateRange $lastModifiedDateRange = null, \StructType\Tags $tags = null)
    {
        $this
            ->setRegistrationKeys($registrationKeys)
            ->setRegistrationStatuses($registrationStatuses)
            ->setRegistrationDateRange($registrationDateRange)
            ->setAccessStartDateRange($accessStartDateRange)
            ->setAccessEndDateRange($accessEndDateRange)
            ->setCompletionDateRange($completionDateRange)
            ->setCourseCodes($courseCodes)
            ->setStudentKeys($studentKeys)
            ->setCustomStudentKeys($customStudentKeys)
            ->setSectionNumbers($sectionNumbers)
            ->setLastModifiedDateRange($lastModifiedDateRange)
            ->setTags($tags);
    }
    /**
     * Get RegistrationKeys value
     * @return \ArrayType\ArrayOfGUID|null
     */
    public function getRegistrationKeys()
    {
        return $this->RegistrationKeys;
    }
    /**
     * Set RegistrationKeys value
     * @param \ArrayType\ArrayOfGUID $registrationKeys
     * @return \StructType\RegistrationsFilter
     */
    public function setRegistrationKeys(\ArrayType\ArrayOfGUID $registrationKeys = null)
    {
        $this->RegistrationKeys = $registrationKeys;
        return $this;
    }
    /**
     * Get RegistrationStatuses value
     * @return \ArrayType\ArrayOfRegistrationStatus|null
     */
    public function getRegistrationStatuses()
    {
        return $this->RegistrationStatuses;
    }
    /**
     * Set RegistrationStatuses value
     * @param \ArrayType\ArrayOfRegistrationStatus $registrationStatuses
     * @return \StructType\RegistrationsFilter
     */
    public function setRegistrationStatuses(\ArrayType\ArrayOfRegistrationStatus $registrationStatuses = null)
    {
        $this->RegistrationStatuses = $registrationStatuses;
        return $this;
    }
    /**
     * Get RegistrationDateRange value
     * @return \StructType\DateRange|null
     */
    public function getRegistrationDateRange()
    {
        return $this->RegistrationDateRange;
    }
    /**
     * Set RegistrationDateRange value
     * @param \StructType\DateRange $registrationDateRange
     * @return \StructType\RegistrationsFilter
     */
    public function setRegistrationDateRange(\StructType\DateRange $registrationDateRange = null)
    {
        $this->RegistrationDateRange = $registrationDateRange;
        return $this;
    }
    /**
     * Get AccessStartDateRange value
     * @return \StructType\DateRange|null
     */
    public function getAccessStartDateRange()
    {
        return $this->AccessStartDateRange;
    }
    /**
     * Set AccessStartDateRange value
     * @param \StructType\DateRange $accessStartDateRange
     * @return \StructType\RegistrationsFilter
     */
    public function setAccessStartDateRange(\StructType\DateRange $accessStartDateRange = null)
    {
        $this->AccessStartDateRange = $accessStartDateRange;
        return $this;
    }
    /**
     * Get AccessEndDateRange value
     * @return \StructType\DateRange|null
     */
    public function getAccessEndDateRange()
    {
        return $this->AccessEndDateRange;
    }
    /**
     * Set AccessEndDateRange value
     * @param \StructType\DateRange $accessEndDateRange
     * @return \StructType\RegistrationsFilter
     */
    public function setAccessEndDateRange(\StructType\DateRange $accessEndDateRange = null)
    {
        $this->AccessEndDateRange = $accessEndDateRange;
        return $this;
    }
    /**
     * Get CompletionDateRange value
     * @return \StructType\DateRange|null
     */
    public function getCompletionDateRange()
    {
        return $this->CompletionDateRange;
    }
    /**
     * Set CompletionDateRange value
     * @param \StructType\DateRange $completionDateRange
     * @return \StructType\RegistrationsFilter
     */
    public function setCompletionDateRange(\StructType\DateRange $completionDateRange = null)
    {
        $this->CompletionDateRange = $completionDateRange;
        return $this;
    }
    /**
     * Get CourseCodes value
     * @return \ArrayType\ArrayOfString1|null
     */
    public function getCourseCodes()
    {
        return $this->CourseCodes;
    }
    /**
     * Set CourseCodes value
     * @param \ArrayType\ArrayOfString1 $courseCodes
     * @return \StructType\RegistrationsFilter
     */
    public function setCourseCodes(\ArrayType\ArrayOfString1 $courseCodes = null)
    {
        $this->CourseCodes = $courseCodes;
        return $this;
    }
    /**
     * Get StudentKeys value
     * @return \ArrayType\ArrayOfGUID1|null
     */
    public function getStudentKeys()
    {
        return $this->StudentKeys;
    }
    /**
     * Set StudentKeys value
     * @param \ArrayType\ArrayOfGUID1 $studentKeys
     * @return \StructType\RegistrationsFilter
     */
    public function setStudentKeys(\ArrayType\ArrayOfGUID1 $studentKeys = null)
    {
        $this->StudentKeys = $studentKeys;
        return $this;
    }
    /**
     * Get CustomStudentKeys value
     * @return \ArrayType\ArrayOfString2|null
     */
    public function getCustomStudentKeys()
    {
        return $this->CustomStudentKeys;
    }
    /**
     * Set CustomStudentKeys value
     * @param \ArrayType\ArrayOfString2 $customStudentKeys
     * @return \StructType\RegistrationsFilter
     */
    public function setCustomStudentKeys(\ArrayType\ArrayOfString2 $customStudentKeys = null)
    {
        $this->CustomStudentKeys = $customStudentKeys;
        return $this;
    }
    /**
     * Get SectionNumbers value
     * @return \ArrayType\ArrayOfString3|null
     */
    public function getSectionNumbers()
    {
        return $this->SectionNumbers;
    }
    /**
     * Set SectionNumbers value
     * @param \ArrayType\ArrayOfString3 $sectionNumbers
     * @return \StructType\RegistrationsFilter
     */
    public function setSectionNumbers(\ArrayType\ArrayOfString3 $sectionNumbers = null)
    {
        $this->SectionNumbers = $sectionNumbers;
        return $this;
    }
    /**
     * Get LastModifiedDateRange value
     * @return \StructType\DateRange|null
     */
    public function getLastModifiedDateRange()
    {
        return $this->LastModifiedDateRange;
    }
    /**
     * Set LastModifiedDateRange value
     * @param \StructType\DateRange $lastModifiedDateRange
     * @return \StructType\RegistrationsFilter
     */
    public function setLastModifiedDateRange(\StructType\DateRange $lastModifiedDateRange = null)
    {
        $this->LastModifiedDateRange = $lastModifiedDateRange;
        return $this;
    }
    /**
     * Get Tags value
     * @return \StructType\Tags|null
     */
    public function getTags()
    {
        return $this->Tags;
    }
    /**
     * Set Tags value
     * @param \StructType\Tags $tags
     * @return \StructType\RegistrationsFilter
     */
    public function setTags(\StructType\Tags $tags = null)
    {
        $this->Tags = $tags;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RegistrationsFilter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
