<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SingleSignOn StructType
 * @subpackage Structs
 */
class SingleSignOn extends AbstractStructBase
{
    /**
     * The Form
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Form
     */
    public $Form;
    /**
     * The AutoPost
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EncodedValue
     */
    public $AutoPost;
    /**
     * The ExpirationDate
     * @var string
     */
    public $ExpirationDate;
    /**
     * Constructor method for SingleSignOn
     * @uses SingleSignOn::setForm()
     * @uses SingleSignOn::setAutoPost()
     * @uses SingleSignOn::setExpirationDate()
     * @param \StructType\Form $form
     * @param \StructType\EncodedValue $autoPost
     * @param string $expirationDate
     */
    public function __construct(\StructType\Form $form = null, \StructType\EncodedValue $autoPost = null, $expirationDate = null)
    {
        $this
            ->setForm($form)
            ->setAutoPost($autoPost)
            ->setExpirationDate($expirationDate);
    }
    /**
     * Get Form value
     * @return \StructType\Form|null
     */
    public function getForm()
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param \StructType\Form $form
     * @return \StructType\SingleSignOn
     */
    public function setForm(\StructType\Form $form = null)
    {
        $this->Form = $form;
        return $this;
    }
    /**
     * Get AutoPost value
     * @return \StructType\EncodedValue|null
     */
    public function getAutoPost()
    {
        return $this->AutoPost;
    }
    /**
     * Set AutoPost value
     * @param \StructType\EncodedValue $autoPost
     * @return \StructType\SingleSignOn
     */
    public function setAutoPost(\StructType\EncodedValue $autoPost = null)
    {
        $this->AutoPost = $autoPost;
        return $this;
    }
    /**
     * Get ExpirationDate value
     * @return string|null
     */
    public function getExpirationDate()
    {
        return $this->ExpirationDate;
    }
    /**
     * Set ExpirationDate value
     * @param string $expirationDate
     * @return \StructType\SingleSignOn
     */
    public function setExpirationDate($expirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($expirationDate) && !is_string($expirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expirationDate)), __LINE__);
        }
        $this->ExpirationDate = $expirationDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SingleSignOn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
